void draw() {

  background(360, 0, 100);

  // printing out text
  for (int i=0; i<arrRankedIndex[0].length; i++) { // row - dewey index
    for (int j=0; j<arrRankedIndex.length; j++) { // column - hour 
      int idx = arrRankedIndex[j][i]; 
      
      textFont(gFont1);
      fill((360/10)*idx, 60, 70);
      text(deweyClass[i], 30, (height/21)*i+border);

      fill(360, 0, 0);
      textAlign(LEFT);
      text(str(arrHours[j]),
           ((width/31.7f)*j+border*4)+190, height-border/2f,
           width/29, border );
    }
  }
  
  // printing out bars
  for (int i=0; i<arrRankedIndex[0].length; i++) {  // row - dewey index
    for (int j=0; j<arrRankedIndex.length; j++) {  // column - hour
      int idx = arrRankedIndex[j][i]; 
   
      stroke(360, 0, 100);
      fill((360/20)*idx, 60, 70);
      rect(((width/31)*j+border*4)+190, (height/21)*i+border/2, width/31/3, height/21 );

      if( key1Pressed )  {
        if( j>0 )  {
          int k = 0;
          for( k=0; k<arrRankedIndex[0].length; k++ )  {
            if( idx == arrRankedIndex[j-1][k] )  {
              break;
            }
          }
          stroke((360/20)*idx, 60, 90);
          strokeWeight(1f);
          line( ((width/31)*(j-1)+border*4)+190 + width/31/3, (height/21)*k+border/2 + height/21/2,
                ((width/31)*j+border*4)+190 + width/31/3, (height/21)*i+border/2 + height/21/2 );
        }
      }
    }
  }
}

