void setup()
{
  
  size(1024,768);
  background(10);
  frameRate(60);
  smooth();
  
  gFont1 = createFont("Arial", 11, false);
  gFont2 = createFont("Helvetica", 18, false);
  gFont3 = createFont("Arial", 15, false);
  
  horizontalSquareSize = width/horizontalGridDivisions;

  // for year: 2005-2011 => idx: 0-6
  // for month: 1-12 => idx: 0-11
  pResult_Bach          = new Integer[7][12];  for(int i=0; i<7; i++) for(int j=0; j<12; j++) pResult_Bach[i][j] = new Integer(0);
  pResult_Beethoven     = new Integer[7][12];  for(int i=0; i<7; i++) for(int j=0; j<12; j++) pResult_Beethoven[i][j] = new Integer(0);
  pResult_Chopin        = new Integer[7][12];  for(int i=0; i<7; i++) for(int j=0; j<12; j++) pResult_Chopin[i][j] = new Integer(0);
  pResult_Handel        = new Integer[7][12];  for(int i=0; i<7; i++) for(int j=0; j<12; j++) pResult_Handel[i][j] = new Integer(0);
  pResult_Haydn         = new Integer[7][12];  for(int i=0; i<7; i++) for(int j=0; j<12; j++) pResult_Haydn[i][j] = new Integer(0);
  pResult_Mozart        = new Integer[7][12];  for(int i=0; i<7; i++) for(int j=0; j<12; j++) pResult_Mozart[i][j] = new Integer(0);
  pResult_Schubert      = new Integer[7][12];  for(int i=0; i<7; i++) for(int j=0; j<12; j++) pResult_Schubert[i][j] = new Integer(0);
  pResult_Schumann      = new Integer[7][12];  for(int i=0; i<7; i++) for(int j=0; j<12; j++) pResult_Schumann[i][j] = new Integer(0);
  pResult_Stravinsky    = new Integer[7][12];  for(int i=0; i<7; i++) for(int j=0; j<12; j++) pResult_Stravinsky[i][j] = new Integer(0);
  pResult_Tchaikovsky   = new Integer[7][12];  for(int i=0; i<7; i++) for(int j=0; j<12; j++) pResult_Tchaikovsky[i][j] = new Integer(0);

  Integer[][][] pDataMatrices = {
    pResult_Bach,
    pResult_Beethoven,
    pResult_Chopin,
    pResult_Handel,
    pResult_Haydn,
    pResult_Mozart,
    pResult_Schubert,
    pResult_Schumann,
    pResult_Stravinsky,
    pResult_Tchaikovsky  };
  gpDataMatrices = pDataMatrices;
  
  boolean[][][] pBarsMouseEvent = new boolean[gpDataMatrices.length][7][12];
  gpBarsMouseEvent = pBarsMouseEvent;
    
  String[] Filenames = {
    "query/Bach.txt",
    "query/Beethoven.txt",
    "query/Chopin.txt",
    "query/Handel.txt",
    "query/Haydn.txt",
    "query/Mozart.txt",
    "query/Schubert.txt",
    "query/Schumann.txt",
    "query/Stravinsky.txt",
    "query/Tchaikovsky.txt"};
    
  // get data
  for (int i=0; i<Filenames.length; i++ )  {
    
    // try to read local file
    println("reading "+Filenames[i]+"...");
    
    String [] textData = loadStrings(Filenames[i]);

    for( int j=1; j<textData.length; j++ )  {
      
      String textSplitted[] = split(textData[j], ",");
      
      int y = (int)Integer.parseInt(textSplitted[0]);
      int m = (int)Integer.parseInt(textSplitted[1]);
      int val = (int)Integer.parseInt(textSplitted[2]);
      
      Integer[][] dataMatrix = pDataMatrices[i];
      dataMatrix[y-2005][m-1] = val;
      
      // store maximum val to normalize
      if( gpMaxDataMatrices < val ) gpMaxDataMatrices = val;
      
//      println(y+" "+m+" "+dataMatrix[y-2005][m-1]);
    }
    
  }
  
  // animation
  gnTimeStart = millis();

}
